//package org.processmining.xlu.experiment.discovery;
//
//import org.deckfour.xes.classification.XEventClassifier;
//import org.deckfour.xes.classification.XEventNameClassifier;
//import org.deckfour.xes.model.XLog;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.models.connections.petrinets.behavioral.FinalMarkingConnection;
//import org.processmining.models.connections.petrinets.behavioral.InitialMarkingConnection;
//import org.processmining.models.graphbased.directed.petrinet.Petrinet;
//import org.processmining.models.semantics.petrinet.Marking;
//import org.processmining.plugins.bpmnminer.causalnet.CausalNet;
//import org.processmining.plugins.bpmnminer.converter.CausalNetToPetrinet;
//import org.processmining.plugins.bpmnminer.plugins.BPMNMinerPlugin;
//import org.processmining.plugins.bpmnminer.types.MinerSettings;
//import org.processmining.plugins.bpmnminer.ui.FullParameterPanel;
//
//public class ExpDiscoveryFodina implements ExpDiscoveryAlgorithm {
//
//	private boolean isDummyEndAdded = true;
//
//	public MarkedPetrinet minePetrinet(PluginContext context, XLog log) {
//		return minePetrinet(context, log, new XEventNameClassifier());
//	}
//
//	public MarkedPetrinet minePetrinet(PluginContext context, XLog log,
//			XEventClassifier classifier) {
//
//		if (isDummyEndAdded) {
//			log = ExpDiscoveryDummyEndUtil.addDummyEndEvents(log, classifier);
//		}
//		
//		MinerSettings minerSettings = new MinerSettings();
////		double nom = (double) log.size()
////				/ ((double) log.size() + (double) minerSettings.dependencyDivisor);
////		if (nom <= 0.0D) {
////			nom = 0.0D;
////		}
////		if (nom >= 0.9D) {
////			nom = 0.9D;
////		}
////		minerSettings.dependencyThreshold = nom;
////		minerSettings.l1lThreshold = nom;
////		minerSettings.l2lThreshold = nom;
//		FullParameterPanel parameters = new FullParameterPanel(minerSettings);
////	            context.showConfiguration("Miner Parameters", parameters);
//		minerSettings = parameters.getSettings();
//		minerSettings.classifier = classifier;
//		
////		minerSettings.duplicateThreshold = 0.9;
////		System.out.println("DUP threshold " + minerSettings.duplicateThreshold);
//
//		Object[] bpmnResults = BPMNMinerPlugin.runMiner(context, log, minerSettings);
//		CausalNet net = (CausalNet) bpmnResults[0];
//
//		Object[] result = CausalNetToPetrinet.convert(context, net);
//
//		Petrinet pnet = (Petrinet) result[0];
//		Marking initialMarking = (Marking) result[1];
//		MarkedPetrinet markednet = null;
//
//		context.getConnectionManager().addConnection(
//				new InitialMarkingConnection(pnet, initialMarking));
//
//		if (isDummyEndAdded) {
//			Marking finalMarking = ExpDiscoveryDummyEndUtil
//					.removeDummyEndTransitionAndReturnFinalMarking(pnet);
//			context.getConnectionManager().addConnection(
//					new FinalMarkingConnection(pnet, finalMarking));
//
//			markednet = new MarkedPetrinet(pnet, initialMarking, finalMarking);
//		} else {
//			markednet = new MarkedPetrinet(pnet, initialMarking);
//		}
//
//		return markednet;
//
//	}
//
//	public String toString(){
//		return "Fodina";
//	}
//}
