package org.processmining.xlu.matching.config.gui;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;

public class EGMatchConfigUserPresetWizard extends EGMatchConfigWizard {

	public EGMatchConfigUserPresetWizard(UIPluginContext context, EGMatchConfiguration conf, XLog log) {
		super(context, conf, log);
	}

	@Override
	protected void initalizeDialogs() {
		EGMatchConfigDialog panel = new XEventClassSelectorPanel(config, log);
		this.dialogs.add(panel);
		
		panel = new PTraceParameterMatchDialog(context, config);
		this.dialogs.add(panel);
		
		panel = new EGMatchingAlgSelectorDialog(config);
		this.dialogs.add(panel);
	}

}
