package org.processmining.xlu.matching.models;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;

public class Tree<T> extends DefaultMutableTreeNode implements MutableTreeNode {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1558742070320558919L;
	T object; 
	
	public Tree(T object) {
		this.object = object;
	}

	public T getObject(){
		return object;
	}
	
	public void setObject(T object){
		this.object = object;
		this.setUserObject(object);
	}
	
	public String toString(){
		if(object == null){
			return "No object";
		}
		return this.object.toString();
	}
    
}