package org.processmining.xlu.matching.models.collection;

import java.util.List;

import org.processmining.partialorder.ptrace.model.PLog;
import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;

public class EGraphsWithMappings extends EGraphs {
	
	MatchMappings mappings;
	EGMatchConfiguration conf;
	PLog plog;



	public EGraphsWithMappings(List<EGraph> graphs, MatchMappings mappings, EGMatchConfiguration conf) {
		super(graphs);
		this.mappings = mappings;
		this.conf = conf; 
	}

	public MatchMappings getMappings() {
		return this.mappings;
	}

	public EGMatchConfiguration getMatchConfiguration() {
		return this.conf;
	}
	

	public PLog getPlog() {
		return plog;
	}

	public void setPlog(PLog plog) {
		this.plog = plog;
	}
	
	
	

}
