package org.processmining.xlu.matching.models.collection;

import java.util.HashSet;
import java.util.Set;

import org.processmining.xlu.matching.models.RepEGraph;

public class RepEGraphsUtil {

	/**
	 * Get a set of ids of graphs
	 * @param graphs
	 * @return
	 */
	public static Set<Integer> getIds(RepEGraphs graphs) {
		Set<Integer> ids = new HashSet<Integer>();
		for (RepEGraph g : graphs.getAllGraphs()) {
			ids.addAll(g.getRepresentedGraphIds());
		}
		return ids;
	}
}
