package org.processmining.xlu.matching.plugins.alg;

import java.util.Set;

import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.models.MatchMapping;

public interface MatchingAlg {

	
	public MatchMapping getOptimalMapping(EGraph g1, EGraph g2); 
	
	public CostStrategy getCostStrategy();
	public void setCostFunction(CostStrategy costfunc);
//	public List<Criterion> getCriteria();
//	public void setCriteria(List<Criterion> criteria);
	
	
	
	public void setMatchingLabelSet(Set<String> labels);
}
