package org.processmining.xlu.matching.zexperiment;

import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;

public class LogRepairTest {
	public static String[] printColumnNames() {
		String[] record = new String[] { 
				"NumNois", "NumRepeat",
				
				"PTraceType", "KNeighbors", //TODO concurrent true or false
//				"CostFunction", "CostFunctionConfig",

				"WMatched", "WNoMatch", "WGlobal", "WBaseCostNoMatch",

				"MatchingAlg", 
//				"Filter", 
//				"Threshold",

//				"TP", "FP", "FN", "TN", 
				"Fitness", "Precision"
		//, "Generalisation"
		};
		return record;
	}

	public static String[] printResult(PTraceType type, EGMatchConfiguration conf, /*int threshold,
			EGFusionFilteringQuality data,*/ ModelQuality quality, String filter, int numRepeat, int numNoise) {
		String[] record = new String[17];
		int i =0;
		record[i++] = String.valueOf(numNoise);
		record[i++] = String.valueOf(numRepeat);
		record[i++] = type.toString();
		record[i++] = String.valueOf(conf.getDist());
//		record[i++] = conf.getCostStrategy().toString();
//		record[i++] = conf.getCostStrategy().getCostConfiguration().getName();

		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightMatched());
		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightNoMatch());
		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightGlobalStructure());
		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightBaseCostForNoMatch());

		record[i++] = conf.getMatchingAlgorithm().toString();
//		record[i++] = String.valueOf(filter);
//		record[i++] = String.valueOf(threshold);

//		record[i++] = String.valueOf(data.truePositiveNoise);
//		record[i++] = String.valueOf(data.falsePositiveNoise);
//		record[i++] = String.valueOf(data.falseNegativeNoise);
//		record[i++] = String.valueOf(data.trueNegativeNoise);

		record[i++] = String.valueOf(quality.fitness);
		record[i++] = String.valueOf(quality.precision);
		//		record[17] = String.valueOf(quality.generalisation);

		return record;
	}
}
