//package org.processmining.xlu.matching.zexperiment;
//
//import java.io.IOException;
//import java.util.List;
//
//import org.deckfour.xes.classification.XEventClasses;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.out.XesXmlGZIPSerializer;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.partialorder.ptrace.model.PLog;
//import org.processmining.partialorder.ptrace.param.PTraceParameter;
//import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
//import org.processmining.partialorder.ptrace.plugins.builder.PLogPlugin;
//import org.processmining.plugins.InductiveMiner.mining.MiningParametersIM;
//import org.processmining.plugins.InductiveMiner.mining.MiningParametersIMi;
//import org.processmining.plugins.InductiveMiner.plugins.IMPetriNet;
//import org.processmining.plugins.pnml.exporting.PnmlExportNetToEPNML;
//import org.processmining.xlu.logrepair.plugins.LogRepairPlugin;
//import org.processmining.xlu.matching.merge.impl.FusionStrategyBinaryVerificationImpl;
//import org.processmining.xlu.matching.merge.impl.FusionStrategyIncrBinaryImpl;
//import org.processmining.xlu.matching.models.collection.EGraphsWithMappings;
//import org.processmining.xlu.matching.models.collection.RepEGraphs;
//import org.processmining.xlu.matching.plugins.EGMatchPlugin;
//import org.processmining.xlu.matching.plugins.alg.CostStrategy;
//import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;
//import org.processmining.xlu.matching.plugins.alg.MatchingAlg;
//import org.processmining.xlu.matching.plugins.alg.conf.impl.EGMatchConfigurationImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;
//import org.processmining.xlu.matching.preprocessing.PTraceToEGConverter;
//import org.processmining.xlu.matching.preprocessing.PTraceToEGConverterCAwareAdaptiveKwithDummyStartEndImpl;
//import org.processmining.xlu.matching.zexperiment.model.QualityTFPN;
//import org.processmining.xlu.matching.zexperiment.verification.EGMatchTestVerificationMethod;
//import org.processmining.xlu.pgraph.vis.filter.PGraphFilterEventFreqImpl;
//import org.processmining.xlu.pgraph.vis.filter.PGraphFilterLabelAEventFreqImpl;
//
//import com.csvreader.CsvWriter;
//
///** =============================================================
// * 
// * This is the core experiment code of BPI experiments. 
// * 
// * 
// * 
// * @author xlu
// *
// * ============================================================= */
//
//public class NewEGMatchAndFusionTestPlugin {
//
//	public static RepEGraphs runEGMatchAndFuseExperiments(PluginContext context, EGMatchExpResultsWriters writers,
//			XLog log, EGMatchExpConfigurationSpace configSpace, EGMatchTestVerificationMethod method, int numRepeat,
//			int numNoise) throws IOException {
//		return runEGMatchAndFuseExperiments(context, writers, log, configSpace, method, null, numRepeat, numNoise);
//
//	}
//
//	/**
//	 * 
//	 * @param context
//	 * @param writers
//	 * @param log
//	 * @param configSpace
//	 * @param method
//	 * @param perfectLog
//	 * @param numRepeat
//	 * @param numNoise
//	 * @return
//	 * @throws IOException
//	 */
//	public static RepEGraphs runEGMatchAndFuseExperiments(PluginContext context, EGMatchExpResultsWriters writers,
//			XLog log, EGMatchExpConfigurationSpace configSpace, EGMatchTestVerificationMethod method, XLog perfectLog,
//			int numRepeat, int numNoise) throws IOException {
//
//		//Init parameters. 
//		CsvWriter csvMatchWriter = writers.getMatchResWriter();
//		CsvWriter csvFusionWriter = writers.getFusionresWriter();
//		
//		XEventClasses classes = XEventClasses.deriveEventClasses(configSpace.getClassifier(), log);
//		PTraceType[] egTypeSelections = configSpace.getPTraceTypes();
//		List<CostStrategyConfiguration> costConfigs = configSpace.getCostConfigs();
//		List<MatchingAlg> algs = configSpace.getMatchingAlgorithms();
//a
//		PLogPlugin plogPlugin = new PLogPlugin();
//		EGMatchPlugin matchPlugin = new EGMatchPlugin();
//		LogRepairPlugin repairPlugin = new LogRepairPlugin();
//
//		XesXmlGZIPSerializer serializer = new XesXmlGZIPSerializer();
//		PnmlExportNetToEPNML pnmlSerializer = new PnmlExportNetToEPNML();
//		RepEGraphs resGraphs = null;
//
//		csvMatchWriter.writeRecord(EGMatchExpPrintResultUtil.printColumnNames());
//		csvFusionWriter.writeRecord(EGFusionTest.printColumnNames());
//
//		
//		ModelQuality qualityOrg = new ModelQuality();
//		if (perfectLog != null) {
//
//			XLog newLog = log;
//			//Fit to discover algorithm to get model (Export to disc?)
//			Object[] nets = IMPetriNet.minePetriNet(context, newLog, new MiningParametersIMi());
//			//								pnmlSerializer.exportPetriNetToEPNMLFile(context, (Petrinet) nets[0], new File("ExperimentResult/SBP1000N1GreedyLogs/Net" + conf.toString()+"F"+threshold+".pnml"));
//			//Get original log and the discovered model => alignment and trace fitness
//			// log + model + alignment => precision and generalization
//			qualityOrg = EGLogDiscoveryTestPluginImpl.runReplayToGetFitnessPrecisionAndGeneralization(
//					context, nets, perfectLog, configSpace.getClassifier());
//		}
//		System.out.println(qualityOrg.fitness + ", " + qualityOrg.precision);
//		
//		for (PTraceType type : egTypeSelections) {
//			PLog pLog = plogPlugin.computePTraces(context, log, new PTraceParameter(type));
//
//			//			for (int kNeighbors = 1; kNeighbors < 4; kNeighbors++) {
//			//				int kNeighbors = 2; // best for greedy
//			int kNeighbors = 1; // best for backtracking
//			PTraceToEGConverter converter = new PTraceToEGConverterCAwareAdaptiveKwithDummyStartEndImpl(kNeighbors,
//					classes);
//
//			EGMatchConfiguration conf = new EGMatchConfigurationImpl();
//			conf.setPTraceParameter(new PTraceParameter(type));
//			conf.setClasses(classes);
//			//				conf.setClassifier(classifier);				
//			conf.setDist(kNeighbors);
//			conf.setConverter(converter);
//
//			for (MatchingAlg alg : algs) {
//				conf.setMatchingAlgorithm(alg);
//				CostStrategy costfunction = alg.getCostStrategy();
//
//				for (CostStrategyConfiguration costConfig : costConfigs) {
//					costfunction.setCostConfiguration(costConfig);
//					alg.setCostFunction(costfunction);
//					conf.setCostStrategy(costfunction);
//
//					//						for (int b = 0; b < 2; b++) {
//					//							conf.setQualityOpt(b == 0 ? false : true);
//					conf.setQualityOpt(true);
//					RunningTimes times = new RunningTimes();
//					EGraphsWithMappings res = matchPlugin.replayLog(context, log, conf);
//					times.computingEGtime = matchPlugin.computingEGEstimatedTime;
//					times.computingMappingTime = matchPlugin.mappingEstimatedTime;
//
//					// == Evaluation : quality of fusion ============================================================
//
//					FusionStrategyIncrBinaryImpl fusionFunction = new FusionStrategyIncrBinaryImpl(log);
//					RepEGraphs resIncGraphs = fusionFunction.fuseEGraphs(res, res.getMappings());
//					resIncGraphs.setLog(log);
//					resIncGraphs.setpLog(pLog);
//					resIncGraphs.setMappings(res.getMappings());
//					times.computingIncFusion = fusionFunction.estimatedTime;
//
////					if (false) {
//						PGraphFilterEventFreqImpl eventFilter = new PGraphFilterEventFreqImpl(null, resIncGraphs);
//						PGraphFilterLabelAEventFreqImpl eventFilter2 = new PGraphFilterLabelAEventFreqImpl(null,
//								resIncGraphs);
//						//						PGraphFilterEventFreqImpl eventFilter2 = eventFilter;
//						for (int threshold = 0; threshold < 101; threshold += 10) {
//							//						int threshold = 0;
//							eventFilter.setThreshold(threshold);
//							QualityTFPN data = EGFusionTest.computeFusionQualityNoise(log,
//									resIncGraphs.getHierarchy(), eventFilter);
//
//							//Compute log (Export to disc?)
//							ModelQuality quality = new ModelQuality();
//							if (perfectLog != null) {
//
//								XLog newLog = eventFilter.getFilteredLog();
//								//								OutputStream output = new FileOutputStream("ExperimentResult/SBP1000N1GreedyLogs/Log" + conf.toString()+"F"+threshold+".xes.gz");
//								//								serializer.serialize(newLog, output);
//
//								//Fit to discover algorithm to get model (Export to disc?)
//								Object[] nets = IMPetriNet.minePetriNet(context, newLog, new MiningParametersIM());
//								//								pnmlSerializer.exportPetriNetToEPNMLFile(context, (Petrinet) nets[0], new File("ExperimentResult/SBP1000N1GreedyLogs/Net" + conf.toString()+"F"+threshold+".pnml"));
//								//Get original log and the discovered model => alignment and trace fitness
//								// log + model + alignment => precision and generalization
//								quality = EGLogDiscoveryTestPluginImpl.runReplayToGetFitnessPrecisionAndGeneralization(
//										context, nets, perfectLog, configSpace.getClassifier());
//
//							}
//							String[] recInc = EGFusionTest.printResult(type, conf, threshold, data, quality, "Filter1",
//									numRepeat, numNoise);
//							csvFusionWriter.writeRecord(recInc);
//							csvFusionWriter.flush();
//
//							// Filter 2
//							eventFilter2.setThreshold(threshold);
//							QualityTFPN data2 = EGFusionTest.computeFusionQualityNoise(log,
//									resIncGraphs.getHierarchy(), eventFilter2);
//							ModelQuality quality2 = new ModelQuality();
//							if (perfectLog != null) {
//
//								XLog newLog = eventFilter2.getFilteredLog();
//								//								OutputStream output = new FileOutputStream("ExperimentResult/SBP1000N1GreedyLogs/Log" + conf.toString()+"F"+threshold+".xes.gz");
//								//								serializer.serialize(newLog, output);
//
//								//Fit to discover algorithm to get model (Export to disc?)
//								Object[] nets = IMPetriNet.minePetriNet(context, newLog, new MiningParametersIM());
//								//								pnmlSerializer.exportPetriNetToEPNMLFile(context, (Petrinet) nets[0], new File("ExperimentResult/SBP1000N1GreedyLogs/Net" + conf.toString()+"F"+threshold+".pnml"));
//								//Get original log and the discovered model => alignment and trace fitness
//								// log + model + alignment => precision and generalization
//								quality2 = EGLogDiscoveryTestPluginImpl.runReplayToGetFitnessPrecisionAndGeneralization(
//										context, nets, perfectLog, configSpace.getClassifier());
//
//							}
//							
//							String[] recInc2 = EGFusionTest.printResult(type, conf, threshold, data2, quality2,
//									"Filter2", numRepeat, numNoise);
//							csvFusionWriter.writeRecord(recInc2);
//							csvFusionWriter.flush();
//						}
////					}
//					//== End Eval 2===========================================================================
//
//					//== begin Log repair test =============================================================
////					XLog filteredLog = repairPlugin.repairLogMainNaiveSequential(resIncGraphs, null);
////					Object[] nets = IMPetriNet.minePetriNet(context, filteredLog, new MiningParametersIM());
////					//								pnmlSerializer.exportPetriNetToEPNMLFile(context, (Petrinet) nets[0], new File("ExperimentResult/SBP1000N1GreedyLogs/Net" + conf.toString()+"F"+threshold+".pnml"));
////					//Get original log and the discovered model => alignment and trace fitness
////					// log + model + alignment => precision and generalization
////					ModelQuality quality = EGLogDiscoveryTestPluginImpl
////							.runReplayToGetFitnessPrecisionAndGeneralization(context, nets, perfectLog, classes);
////					String[] recInc = LogRepairTest.printResult(type, conf, quality, "Repair", numRepeat, numNoise);
////					writers.getFilterResWriter().writeRecord(recInc);
////					writers.getFilterResWriter().flush();
//					//== end =================================================================================
//
//					// == Evaluation : quality of individual mappings ============================================================
//					if (false) {
//						FusionStrategyBinaryVerificationImpl bifusionFunction = new FusionStrategyBinaryVerificationImpl(
//								pLog, !conf.isQualityOpt(), method);
//						resGraphs = bifusionFunction.fuseEGraphs(res, res.getMappings());
//						times.computingBinaryFusion = bifusionFunction.estimatedTime;
//
//						//							printResult(type, conf, fusionFunction.getData());
//						String[] rec = EGMatchExpPrintResultUtil.printResult(type, conf, bifusionFunction.getData(),
//								times, numRepeat, numNoise);
//						csvMatchWriter.writeRecord(rec);
//						csvMatchWriter.flush();
//					}
//					//== End Eval 1===========================================================================
//
//					// == Evaluation : quality of fusion ============================================================
//
//					//							FusionStrategyIncrBinaryImpl fusionFunction = new FusionStrategyIncrBinaryImpl(log);
//					//						if (!(alg instanceof MatchingAlgGreedyImp)) {
//					//
//					//							resIncGraphs = fusionFunction.fuseEGraphs(res, bifusionFunction.getQualityOpts());
//					//
//					//							for (int threshold = 0; threshold < 100; threshold += 10) {
//					//								EGFusionFilteringQuality data = EGFusionTestPluginAbstract.computeFusionQualityNoise(
//					//										log, resIncGraphs.getHierarchy(), threshold);
//					//								String[] recInc = EGFusionTestPluginAbstract.printResult(type, conf, threshold, data,
//					//										new ModelQuality());
//					//								csvOptFusionWriter.writeRecord(recInc);
//					//								csvOptFusionWriter.flush();
//					//							}
//					//						}
//					//== End Eval 2===========================================================================
//
//					//						} // boolean opt
//				} // cost function
//			} // matching algorithm
//				//			} // kNeighbor
//		} // PTraceType
//			//		csvOptFusionWriter.close();
//		return resGraphs;
//
//	}
//
//}
