//package org.processmining.xlu.matching.zexperiment;
//
//import java.io.File;
//import java.text.SimpleDateFormat;
//import java.util.ArrayList;
//import java.util.Date;
//import java.util.List;
//
//import org.deckfour.xes.classification.XEventClassifier;
//import org.deckfour.xes.classification.XEventNameClassifier;
//import org.deckfour.xes.in.XesXmlGZIPParser;
//import org.deckfour.xes.model.XLog;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.plugin.annotations.PluginCategory;
//import org.processmining.framework.plugin.annotations.PluginVariant;
//import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
//import org.processmining.xlu.matching.models.collection.RepEGraphs;
//import org.processmining.xlu.matching.plugins.alg.CostStrategy;
//import org.processmining.xlu.matching.plugins.alg.ENodeContextComparator;
//import org.processmining.xlu.matching.plugins.alg.MatchingAlg;
//import org.processmining.xlu.matching.plugins.alg.impl.CostFunctionImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.CostHeuristicFunctionComplexImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;
//import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyWeightsImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.MatchingAlgGreedyImp;
//import org.processmining.xlu.matching.zexperiment.verification.EGMatchTestVerificationMethodGeneratedImpl;
//
///**
// * 
// * This plugin test the EGMatchPlugin using randomly generated noise
// * 
// * @author xlu
// * 
// */
//@Plugin(name = "Trace Mapping Expriment - Generated data", returnLabels = { "RepEGraphs" },
//		returnTypes = { RepEGraphs.class }, parameterLabels = { "Event Log", "Parameters", "Perfect Log" },
//		categories = { PluginCategory.Discovery, PluginCategory.Analytics }, keywords = { "Clustering" },
//		help = "Execute an experiment", userAccessible = true)
//public class NewEGMatchTestPluginGeneratedDataSetImpl {
//
//	private EGMatchExpResultsWriters createWriters() {
//		long yourmilliseconds = System.currentTimeMillis();
//		SimpleDateFormat sdf = new SimpleDateFormat("MMMdd-HHmmss");
//		Date resultdate = new Date(yourmilliseconds);
//		String runday = sdf.format(resultdate);
//		String dir = "./results/";
//		String matchResFile = "SBPG2_Match_" + runday;
//		String fusionResFile = "SBPG2_Fusion_" + runday;
//		String filterResFile = "SBPG2_Repair_" + runday;
//
//		EGMatchExpResultsWriters writers = new EGMatchExpResultsWriters(dir, matchResFile, fusionResFile, filterResFile);
//
//		return writers;
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "x.lu", email = "x.lu@tue.nl", pack = "")
//	@PluginVariant(variantLabel = "default", requiredParameterLabels = { 0 })
//	public RepEGraphs testNoPerfectLog(PluginContext context, XLog log) throws Exception {
//		return test(context, log, null);
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "x.lu", email = "x.lu@tue.nl", pack = "")
//	@PluginVariant(variantLabel = "default", requiredParameterLabels = {})
//	public RepEGraphs testNoPerfectLog(PluginContext context) throws Exception {
//		return test(context, null, null);
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "x.lu", email = "x.lu@tue.nl", pack = "")
//	@PluginVariant(variantLabel = "default", requiredParameterLabels = { 0, 2 })
//	public RepEGraphs test(PluginContext context, XLog origlog, XLog perfectLog) throws Exception {
//
//		int model = 0;
//		EGMatchExpResultsWriters writers = createWriters();
//		EGMatchExpConfigurationSpace configSpace = createExperimentConfigurationSpace();
//
//		//		XesXmlGZIPSerializer serializer = new XesXmlGZIPSerializer();
//		XesXmlGZIPParser parser = new XesXmlGZIPParser();
//		//		XesXmlParser parser = new XesXmlParser();
//		for (int numNoise = 1; numNoise < 6; numNoise++) {
//			//			int numNoise = 1;
//
//			for (int numRepeat = 1; numRepeat < 6; numRepeat++) {
//				//			int numRepeat = 5;
//				//		XLog log = (XLog) origlog.clone();
//
//				// Only for graph2~!!!!!
//				XLog log = parser.parse(new File("./exp2logs/SBP_N" + numNoise + "R" + numRepeat + ".xes.gz")).get(0);
//
//				// Add duplicated labels
////				ExperimentSBP.addDuplicatedLabels(log);
//				//		boolean addDataDependencies = true;
//				//		XExperimentNoiseExtension.copyOrReindexEvents(log, numNoise, false, addDataDependencies);
//				//		XExperimentNoiseExtension.addUniqueLabelToEvent(log, classes);
//
//				//		OutputStream output = new FileOutputStream("D:/data/Experiments/ExperimentResult/mar17logs/GLog" + model +"_N" + numNoise+"R"+numRepeat+".xes.gz");
//				//		serializer.serialize(log, output);
//
//				RepEGraphs resGraphs = NewEGMatchAndFusionTestPlugin.runEGMatchAndFuseExperiments(context, writers,
//						log,
//						/*
//						 * classes, egTypeSelections, algs, costfunction,
//						 * costConfigs,
//						 */configSpace, new EGMatchTestVerificationMethodGeneratedImpl(), perfectLog, numRepeat, numNoise);
//				//		RepEGraphs resGraphs = runEGMatchExperiments(context, csvWriter, log, classes, egTypeSelections, algs, costfunction, costConfigs, new EGMatchTestVerificationMethodGeneratedImpl());
//			}
//		}
//		writers.closeAllWriters();
//		return null;
//	}
//
//	private EGMatchExpConfigurationSpace createExperimentConfigurationSpace() {
//
//		EGMatchExpConfigurationSpace configSpace = new EGMatchExpConfigurationSpace();
//
//		// Set Classifier. 
//		XEventClassifier classifier = new XEventNameClassifier();
//		configSpace.setClassifier(classifier);
//
//		// Set Partial order type
//		PTraceType[] egTypeSelections = new PTraceType[] {
//		//			
//		//			PTraceType.Non_Same_Day_Dependency, 
////		PTraceType.Data_Dependency,
//					PTraceType.Sequential_Dependency
//		};
//		configSpace.setPTraceTypes(egTypeSelections);
//
//		// Set Algorithms
//		List<MatchingAlg> algs = new ArrayList<MatchingAlg>();
//		//		algs.add(new MatchingAlgBackTrackingBFImpl());
//		//		algs.add(new MatchingAllAlgBackTrackingBFImpl());
//		CostStrategy costfunction = new CostFunctionImpl();
//		//				MatchingAlgBackTrackingPruningImpl alg = new MatchingAlgBackTrackingPruningImpl();
//		MatchingAlgGreedyImp alg = new MatchingAlgGreedyImp();
//		//		MatchingAlg alg = new MatchingAllAlgBackTrackingBFImpl();
//		alg.setCostFunction(costfunction);
//		alg.setHeuristicfunction(new CostHeuristicFunctionComplexImpl());
//		alg.setNodeComparator(new ENodeContextComparator());
//		algs.add(alg);
//
//		//				MatchingAlgBackTrackingPruningImpl alg2 = new MatchingAlgBackTrackingPruningImpl();
//		////		MatchingAlgGreedyImp alg = new MatchingAlgGreedyImp();
//		//		//		MatchingAlg alg = new MatchingAllAlgBackTrackingBFImpl();
//		//		alg2.setCostFunction(costfunction);
//		//		alg2.setHeuristicfunction(new CostHeuristicFunctionComplexImpl());
//		////		alg2.setNodeComparator(new ENodeContextComparator());
//		//		algs.add(alg2);
//		configSpace.setMatchAlgorithms(algs);
//
//		//Set Cost configurations. 
//		List<CostStrategyConfiguration> costConfigs = new ArrayList<CostStrategyConfiguration>();
//		//				for (int wMatch = 1; wMatch < 3; wMatch++) {
//		//					for (int wNoMatch = 1; wNoMatch < 3; wNoMatch++) {
//		//						global: for (int wGlobal = 1; wGlobal < 3; wGlobal++) {
//		//							for (int wBase = 1; wBase < 6; wBase += 2) {
//		//								//						if(wMatch == wNoMatch && wNoMatch == wGlobal){
//		//								//							if(wGlobal != 1){
//		//								//								continue global;
//		//								//							}
//		//								//						}
//		//								CostStrategyConfiguration conf = new CostStrategyWeightsImpl();
//		//								conf.setWeightBaseCostForNoMatch(wBase);
//		//								conf.setWeightGlobalStructure(wGlobal);
//		//								conf.setWeightMatched(wMatch);
//		//								conf.setWeightNoMatch(wNoMatch);
//		//								costConfigs.add(conf);
//		//							}
//		//						}
//		//					}
//		//				}
//		CostStrategyConfiguration cfconf = new CostStrategyWeightsImpl();
//
//		// Setting for greedy
//		cfconf.setWeightMatched(2);
//		cfconf.setWeightNoMatch(1);
//		cfconf.setWeightGlobalStructure(1);
//		cfconf.setWeightBaseCostForNoMatch(5);
//		costConfigs.add(cfconf);
//
//		// Best Setting for backtracking
//		//		cfconf.setWeightMatched(1);
//		//		cfconf.setWeightNoMatch(1);
//		//		cfconf.setWeightGlobalStructure(1);
//		//		cfconf.setWeightBaseCostForNoMatch(1);
//		//		costConfigs.add(cfconf);
//
//		configSpace.setCostConfigs(costConfigs);
//		return configSpace;
//	}
//}
