//package org.processmining.xlu.matching.zexperiment;
//
//import java.io.IOException;
//import java.text.SimpleDateFormat;
//import java.util.ArrayList;
//import java.util.Date;
//import java.util.List;
//
//import org.deckfour.xes.classification.XEventClassifier;
//import org.deckfour.xes.classification.XEventNameClassifier;
//import org.deckfour.xes.model.XLog;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.plugin.annotations.PluginCategory;
//import org.processmining.framework.plugin.annotations.PluginVariant;
//import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
//import org.processmining.xlu.experiment.mu.MUDATAPreprocess;
//import org.processmining.xlu.matching.models.collection.RepEGraphs;
//import org.processmining.xlu.matching.plugins.alg.CostStrategy;
//import org.processmining.xlu.matching.plugins.alg.ENodeContextComparator;
//import org.processmining.xlu.matching.plugins.alg.MatchingAlg;
//import org.processmining.xlu.matching.plugins.alg.impl.CostFunctionImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.CostHeuristicFunctionComplexImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;
//import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyWeightsImpl;
//import org.processmining.xlu.matching.plugins.alg.impl.MatchingAlgGreedyImp;
//import org.processmining.xlu.matching.zexperiment.verification.EGMatchTestVerificationMethodMUDataImpl;
//
//@Plugin(name = "Trace Mapping Expriment - MU", returnLabels = { "RepEGraphs" }, returnTypes = { RepEGraphs.class },
//		parameterLabels = { "Event Log", "Parameters" }, categories = { PluginCategory.Discovery,
//				PluginCategory.Analytics }, keywords = { "Clustering" }, help = "Execute an experiment",
//		userAccessible = true)
//public class NewEGMatchTestPluginMUDataSetImpl {
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "x.lu", email = "x.lu@tue.nl", pack = "")
//	@PluginVariant(variantLabel = "default", requiredParameterLabels = { 0 })
//	public RepEGraphs test(PluginContext context, XLog log) throws IOException {
//
//		EGMatchExpResultsWriters writers = createWriters();
//		EGMatchExpConfigurationSpace configSpace = createExperimentConfigurationSpace();
//
////		preprocessAndUpdateLogForExperiment(log);
//
//		RepEGraphs resGraphs = NewEGMatchAndFusionTestPlugin.runEGMatchAndFuseExperiments(context, writers, log, configSpace,
//				new EGMatchTestVerificationMethodMUDataImpl(), 0, 0);
//
//		writers.closeAllWriters();
//		return resGraphs;
//	}
//	
//
//	private EGMatchExpConfigurationSpace createExperimentConfigurationSpace() {
//
//		EGMatchExpConfigurationSpace configSpace = new EGMatchExpConfigurationSpace();
//
////		XEventClassifier classifier = new XEventAttributeClassifier("Org", "Verrichttekst_1");
//		XEventClassifier classifier = new XEventNameClassifier();
//		configSpace.setClassifier(classifier);
//		
//		PTraceType[] egTraceTypes = new PTraceType[] {
//		//PTraceType.Sequential_Dependency, 
//		PTraceType.Non_Same_Day_Dependency };
//
//		configSpace.setPTraceTypes(egTraceTypes);
//
//		List<MatchingAlg> algs = new ArrayList<MatchingAlg>();
//		//		algs.add(new MatchingAlgBackTrackingBFImpl());
//		//		algs.add(new MatchingAllAlgBackTrackingBFImpl());
//
//		CostStrategy costfunction = new CostFunctionImpl();
//		MatchingAlgGreedyImp alg = new MatchingAlgGreedyImp();
//		alg.setCostFunction(costfunction);
//		alg.setHeuristicfunction(new CostHeuristicFunctionComplexImpl());
//		alg.setNodeComparator(new ENodeContextComparator());
//		algs.add(alg);
//		configSpace.setMatchAlgorithms(algs);
//
//		//TODO
//		List<CostStrategyConfiguration> costConfigs = new ArrayList<CostStrategyConfiguration>();
//		for (int wMatch = 1; wMatch < 3; wMatch++) {
//			for (int wNoMatch = 1; wNoMatch < 3; wNoMatch++) {
//				global: for (int wGlobal = 1; wGlobal < 3; wGlobal++) {
//					for (int wBase = 3; wBase < 6; wBase += 2) {
////						if (wMatch == wNoMatch && wNoMatch == wGlobal) {
////							if (wGlobal != 1) {
////								continue global;
////							}
////						}
//						CostStrategyConfiguration conf = new CostStrategyWeightsImpl();
//						conf.setWeightBaseCostForNoMatch(wBase);
//						conf.setWeightGlobalStructure(wGlobal);
//						conf.setWeightMatched(wMatch);
//						conf.setWeightNoMatch(wNoMatch);
//						costConfigs.add(conf);
//					}
//				}
//			}
//		}
//
////		CostStrategyConfiguration cfconf = new CostStrategyWeightsImpl();
////		cfconf.setWeightBaseCostForNoMatch(3);
////		cfconf.setWeightGlobalStructure(2);
////		cfconf.setWeightMatched(2);
////		cfconf.setWeightNoMatch(2);
////		costConfigs.add(cfconf);
//		//		CostStrategy costfunction = new CostFunctionImpl();
//
//		configSpace.setCostConfigs(costConfigs);
//		return configSpace;
//	}
//
//	public static EGMatchExpResultsWriters createWriters() {
//		long yourmilliseconds = System.currentTimeMillis();
//		SimpleDateFormat sdf = new SimpleDateFormat("MMMdd-HHmmss");
//		Date resultdate = new Date(yourmilliseconds);
//		String runday = sdf.format(resultdate);
//		String dir = "D:/data/Experiments/ExperimentResult/";
//		String matchResFile = "MU_Match_result_" + runday + ".csv";
//		String fusionResFile = "MU_Fusion_result_" + runday + ".csv";
//		String filterResFile = "MU_Filter_result_" + runday + ".csv";
//
//		EGMatchExpResultsWriters writers = new EGMatchExpResultsWriters(dir, matchResFile, fusionResFile, filterResFile);
//
//		return writers;
//	}
//
//	public static void preprocessAndUpdateLogForExperiment(XLog log) {
//		MUDATAPreprocess.updateMUDataLog(log);
//	}
//
//	//	private XEventClasses getXEventClassesForMatching(XLog log) {
//	//		XEventClasses classes = XEventClasses.deriveEventClasses(classifier, log);
//	//		return classes;
//	//	}
//
//	public static String[] MU_RENAME_TEST = new String[] { "Na OK consult",
//			"1e_oogl.-extracaps.extract. impl.lens a.o.k", "Na 2eOK consult",
//			"2e_oogl.-extracaps.extract. impl.lens a.o.k", "Poli consult",
//			"2e_ooglens-cataractop.extracaps.inbr.kunstl", "1e_ooglens-cataractop.extracaps.inbr.kunstl",
//			"Oog meting consult" };
//}
