package org.processmining.xlu.pgraph.vis.filter.expander;

import javax.swing.JTree;

import org.processmining.xlu.matching.models.Tree;

public class ClusterExpanderAll<T> implements ClusterExpander<T> {

	public void expandTree(JTree tree, Tree<T> hierarchy) {
		expandAllNodes(tree, 0, tree.getRowCount());
	}

	private void expandAllNodes(JTree tree, int startingIndex, int rowCount) {
		for (int i = startingIndex; i < rowCount; ++i) {
			tree.expandRow(i);
		}
		if (tree.getRowCount() != rowCount) {
			expandAllNodes(tree, rowCount, tree.getRowCount());
		}
	}

}
