package org.processmining.xlu.pgraph.vis.filter.panel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashSet;
import java.util.Set;

import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JPanel;

import org.processmining.xlu.pgraph.vis.filter.PGraphFilterTraceId;

import com.fluxicon.slickerbox.factory.SlickerDecorator;
import com.fluxicon.slickerbox.factory.SlickerFactory;

public class FilterViewTraceId extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6519222140540172548L;

	public FilterViewTraceId(final PGraphFilterTraceId filter, Set<Integer> availableIds) {
		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		add(SlickerFactory.instance().createLabel("Find trace: "));

		final JComboBox<Integer> select = new JComboBox<Integer>(availableIds.toArray(new Integer[availableIds.size()]));
		select.setSelectedIndex(0);
		SlickerDecorator.instance().decorate(select);
		select.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				Integer value = (Integer) select.getSelectedItem();
				Set<Integer> ids = new HashSet<>();
				ids.add(value);
				filter.setSelectedTraceIds(ids);
			}
		});

		add(select);
	}

}
