package org.processmining.xlu.pgraph.vis.panel;

import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JScrollPane;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.partialorder.util.VisUtil;

import info.clearthought.layout.TableLayout;

public class PGraphMainView extends JComponent {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1449220156529621755L;
	private PluginContext context;
	private JComponent graphPanel;
	private JComponent controlPanel;
	
	public PGraphMainView(PluginContext context, JComponent graphPanel, JComponent controlPanel){
		this.context = context;
		
//		setLayout(new BorderLayout());
//		ProMSplitPane splitPane = new ProMSplitPane(ProMSplitPane.HORIZONTAL_SPLIT);		
//		splitPane.setResizeWeight(1.0d);
//		splitPane.setBorder(BorderFactory.createEmptyBorder());
//		splitPane.setBackground(Color.DARK_GRAY);
//		splitPane.setForeground(Color.WHITE);
		
		initLayout();
		
		// Add Visual Panel and control panel
		this.graphPanel = graphPanel;
		this.controlPanel = controlPanel;
		
		JScrollPane graphListScrollPane = VisUtil.getProMStyleVerticalScrollPane(this.graphPanel);
		
		graphListScrollPane.setBackground(Color.DARK_GRAY);
		graphListScrollPane.setForeground(Color.WHITE);
		
//		splitPane.setLeftComponent(this.controlPanel);
//		splitPane.setRightComponent(graphListScrollPane);
		this.add(this.controlPanel, "0,0");
		this.add(graphListScrollPane, "1,0");
		
//		add(splitPane, BorderLayout.CENTER);
		
	}

	private void initLayout() {
		TableLayout mainLayout = new TableLayout(new double[][] {
				{ 300, TableLayout.FILL }, { TableLayout.FILL } });
		setLayout(mainLayout);
		setBorder(BorderFactory.createEmptyBorder());
		setBackground(Color.DARK_GRAY);
		setForeground(Color.WHITE);
	}

//	protected abstract Component getComponentControllerPanel();


//	protected JComponent getComponentGraphListScrollPanel() {
////		JPanel graphListPanel = new JPanel();
////		graphListPanel.setLayout(new BoxLayout(graphListPanel, BoxLayout.Y_AXIS));
//		JPanel graphListPanel = getComponentGraphListPanel();
//		JScrollPane graphListScrollPane = VisUtil.getProMStyleScrollPane(graphListPanel);
//		return graphListScrollPane;
//	}


//	private JPanel getComponentGraphListPanel() {
//		// TODO Auto-generated method stub
//		return null;
//	}

}
