package org.processmining.xlu.relabel.experiment;

import java.util.List;
import java.util.Map;
import java.util.Set;

public interface ExpImprLabelSetI<T> {

	/**
	 * @return the original task A that is relabeled as getNodeB().
	 */
	public abstract Set<T> getNodeAs(); 
	public abstract T getNodeB();

	public abstract T getMinimalSharedParent();

	public abstract Map<T, List<T>> getPathToA();

	public abstract List<T> getPathToB();

	public abstract List<T> getPathToRoot();

}