package org.processmining.xlu.relabel.experiment;

import java.util.ArrayList;
import java.util.List;

import org.processmining.xlu.matching.config.EGMatchConfigurationFactory;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;

public class ExpRelabelingParamSBP extends ExpRelabelingParam {
	
	@Override
	public List<ExpImprLabelPair<String>> getDupPairs() {
		List<ExpImprLabelPair<String>> list = new ArrayList<ExpImprLabelPair<String>>();
		list.add(new ExpImprLabelPair<String>("Appointment",
				"Radiology"));
		
		return list ;
	}
	
	@Override
	public EGMatchConfiguration getTraceMatchingConfiguration() {
		EGMatchConfiguration config = EGMatchConfigurationFactory
				.createDataBasedDefaultConfig();

//		EGMatchConfiguration config = EGMatchConfigurationFactory
//				.createSeqBasedDefaultConfig();
//		
//		EGMatchConfiguration config = EGMatchConfigurationFactory
//				.createSeqBasedGreedyConfig();
		
//		EGMatchConfiguration config = EGMatchConfigurationFactory
//				.createTimeBasedPOGreedyConfig();

		return config;
	}


}
