package org.processmining.xlu.relabel.param;

import org.processmining.xlu.relabel.plugin.detection.ILDetector;
import org.processmining.xlu.relabel.plugin.detection.ILDetectorParam;
import org.processmining.xlu.relabel.plugin.matching.Replacer;

public abstract class RelabelParam<M, S> extends RelabelCoreParam {
	
//	enum RelabelerType {
//		LOCAL, GLOBAL;
//	}

	private ILDetector<M, S> detector;
	private ILDetectorParam detectorParam;
	
	private Replacer<M, S> replacer;	
	

	public ILDetector<M, S> getDetector() {
		return detector;
	}

	public void setDetector(ILDetector<M, S> detector) {
		this.detector = detector;
	}

	public ILDetectorParam getDetectorParam() {
		return detectorParam;
	}

	public void setDetectorParam(ILDetectorParam detectorParam) {
		this.detectorParam = detectorParam;
	}




	public Replacer<M, S> getReplacer() {
		return replacer;
	}

	public void setReplacer(Replacer<M, S> replacer) {
		this.replacer = replacer;
	}

}
