package org.processmining.xlu.relabel.plugin.detection;

import java.util.Collection;
import java.util.Set;

import org.deckfour.xes.model.XLog;

public interface RelabelScope<M, S> {

	public M getModel();

	public S getSubmodel();

	public Set<String> getLabelScope();

	public XLog getLogForRelabel();

	public XLog getOrigLog();

	public void setSubModel(S subtree);
	
	public void setLabelScope(Collection<String> impreciseLabels);

}
