package org.processmining.xlu.relabel.plugin.detection;

import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;

public class RelabelScopePT extends RelabelScopeAbs<ProcessTree, Node> {
	


	public static RelabelScopePT createScope(ProcessTree model, Node submodel,
			Set<String> labels, XLog origlog, XLog sublog) {
		RelabelScopePT scope = new RelabelScopePT();
		scope.setModel(model);
		scope.setSubModel(submodel);
		scope.setOrigLog(origlog);
		scope.setSublog(sublog);
		scope.setLabelScope(labels);
		return scope;
	}

}
