package org.processmining.xlu.relabel.plugin.hyber;

import gnu.trove.map.hash.THashMap;

import java.util.Map;

import org.processmining.plugins.InductiveMiner.mining.IMLogInfo;
import org.processmining.plugins.InductiveMiner.mining.MinerState;
import org.processmining.plugins.InductiveMiner.mining.logs.IMLog;
import org.processmining.plugins.InductiveMiner.mining.postprocessor.PostProcessor;
import org.processmining.processtree.Node;

public class IMSubLogPostProcessor implements PostProcessor {

	public Map<Node, IMLog> mapNode2Log;
	
	public IMSubLogPostProcessor() {
		this.mapNode2Log = new THashMap<Node, IMLog>();
	}
	
	public Node postProcess(Node node, IMLog log, IMLogInfo logInfo, MinerState minerState) {
		mapNode2Log.put(node, log);
		return node;
	}

	public Map<Node, IMLog> getMapNodeToLog(){
		return mapNode2Log;
	}
}
