package org.processmining.xlu.relabel.plugin.matching;

import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.xlu.relabel.model.RelabelModel;
import org.processmining.xlu.relabel.param.RelabelCoreParam;

public interface ModelCreator {

//	public RelabelModel createRelabelModel(XLog log);

	public RelabelModel createRelabelModel(XLog log, Set<String> impreciseLabels,
			RelabelCoreParam param);

	public XLog applyRelabeling(RelabelModel model, RelabelCoreParam param);

}