package org.processmining.xlu.relabel.plugin.matching;

import org.deckfour.xes.model.XLog;
import org.processmining.plugins.InductiveMiner.mining.MiningParametersIM;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.xlu.experiment.discovery.ExpDiscoveryInductiveMiner;
import org.processmining.xlu.relabel.plugin.detection.RelabelScope;

public class ReplacerIMGlobal implements Replacer<ProcessTree, Node> {

	public ProcessTree rediscover(RelabelScope<ProcessTree, Node> scope, XLog refinedLog) {

		MiningParametersIM imParam = new MiningParametersIM();
//			imParam.setClassifier(param.getClassifier());
		ExpDiscoveryInductiveMiner miner = new ExpDiscoveryInductiveMiner();
		ProcessTree tree = miner.mineTree(refinedLog, imParam.getClassifier());
//		ReplacerIMLocal.changeTransitionLabels(tree);
		return tree;
	}

}
