//package org.processmining.xlu.experiment.alignment;
//
//import java.util.Calendar;
//import java.util.Date;
//import java.util.Random;
//
//import org.deckfour.xes.classification.XEventAttributeClassifier;
//import org.deckfour.xes.classification.XEventNameClassifier;
//import org.deckfour.xes.extension.std.XConceptExtension;
//import org.deckfour.xes.extension.std.XTimeExtension;
//import org.deckfour.xes.factory.XFactory;
//import org.deckfour.xes.factory.XFactoryRegistry;
//import org.deckfour.xes.model.XEvent;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.model.XTrace;
//import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
//import org.processmining.contexts.uitopia.UIPluginContext;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.plugin.annotations.PluginVariant;
//
//@Plugin(name = "MU_Artifial_Log", returnLabels = { "Experiment" }, returnTypes = { XLog.class }, parameterLabels = {
//		"Petri net", "Event Log" })
//public class ExperimentLogGen {
//
//	XFactory factory;
//	Random random;
//	Calendar calendar;
//	
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Generate log", requiredParameterLabels = {})
//	public XLog runOld(final UIPluginContext context) throws Exception {
//		
//		factory = XFactoryRegistry.instance().currentDefault();
//		random = new Random();
//		calendar =  Calendar.getInstance();
//		
//		int numCases = 1000;
//		
//		XLog log = factory.createLog();
//
//		for (int i = 0; i < numCases; i++) {
//			XTrace t = factory.createTrace();
//			XConceptExtension.instance().assignName(t, String.valueOf(i));
//			// add consult
//			Date startDate = setDate();
//			 
//			XEvent poliConsult = createEventWithAttributes("Consult", "Poli Consult", startDate);
//			t.add(poliConsult);
//			// 
//			
//			calendar.add(Calendar.DATE, 1);
//			Date nextDate = calendar.getTime();
//			
//			XEvent testA = createEventWithAttributes("Test A", "Test A", nextDate);
//			t.add(testA);
//			
//			XEvent testB = createEventWithAttributes("Test B", "Test B", nextDate);
//			t.add(randBetween(1, 3), testB);
//			
//			XEvent testC = createEventWithAttributes("Test C", "Test C", nextDate);
//			t.add(randBetween(1, 4), testC);
//			
//			XEvent consult = createEventWithAttributes("Consult", "Test Consult", nextDate);
////			t.add(randBetween(1, 5), consult);
//			t.add(randBetween(1, 5), consult);
//			
//			calendar.add(Calendar.DATE, 1);
//			nextDate = calendar.getTime();
//			XEvent sugery = createEventWithAttributes("Surgery", "Surgery 1", nextDate);
//			t.add(sugery);
//			
//			calendar.add(Calendar.DATE, 1);
//			nextDate = calendar.getTime();
//			XEvent consult1 = createEventWithAttributes("Consult", "SConsult 1", nextDate);
//			t.add(consult1);
//			
//			if(randBetween(1, 3) == 1){
//				calendar.add(Calendar.DATE, 1);
//				nextDate = calendar.getTime();
//				XEvent sugery2 = createEventWithAttributes("Surgery", "Surgery 2", nextDate);
//				t.add(sugery2);
//				
//				calendar.add(Calendar.DATE, 1);
//				nextDate = calendar.getTime();
//				XEvent consult2 = createEventWithAttributes("Consult", "SConsult 2", nextDate);
//				t.add(consult2);
//			} else {
//				XEvent consult2 = createEventWithAttributes("Skip", "Skip", nextDate);
//				t.add(consult2);
//			}
//			
//			log.add(t);
//		}
//		
//		log.getClassifiers().add(new XEventNameClassifier());
//		log.getClassifiers().add(new XEventAttributeClassifier("TrueLabel", XExperimentNoiseExtension.KEY_TRUELABEL));
//		if(log.size() == 0){
//			System.out.println("000");
//		}
//		
//		
//
//		return log;
//
//	}
//	
//	
//
//	private XEvent createEventWithAttributes(String label, String truelabel, Date timestamp) {
//		XEvent e = factory.createEvent();
//		XConceptExtension.instance().assignName(e, label);
//		e.getAttributes().put(XExperimentNoiseExtension.KEY_TRUELABEL, new XAttributeLiteralImpl(XExperimentNoiseExtension.KEY_TRUELABEL, truelabel));
//		XTimeExtension.instance().assignTimestamp(e, timestamp);
//		
//		return e;
//	}
//
//	private Date setDate() {
//		int year = randBetween(2000, 2010);// generate a year between 1900 and 2010;
//		int dayOfYear = randBetween(1, 365);// generate a number between 1 and 365 (or 366 if you need to handle leap year);
//		
//		calendar.set(Calendar.YEAR, year);
//		calendar.set(Calendar.DAY_OF_YEAR, dayOfYear);
//		Date randomDoB = calendar.getTime();
//		return randomDoB;
//	}
//
//	/**
//	 * Note that the lower limit is inclusive, but the upper limit is exclusive.
//	 * @param min
//	 * @param max
//	 * @return
//	 */
//	public int randBetween(int min, int max) {
//		return random.nextInt(max - min) + min;
//	}
//}
