//package org.processmining.xlu.experiment.alignment;
//
//import org.deckfour.xes.extension.std.XConceptExtension;
//import org.deckfour.xes.model.XAttribute;
//import org.deckfour.xes.model.XAttributeLiteral;
//import org.deckfour.xes.model.XEvent;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.model.XTrace;
//import org.processmining.connection.PAlignmentResultConnection;
//import org.processmining.contexts.uitopia.UIPluginContext;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.plugin.annotations.PluginVariant;
//import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
//import org.processmining.partialorder.models.replay.POSyncReplayResult;
//import org.processmining.partialorder.ptrace.model.PLog;
//import org.processmining.plugins.connectionfactories.logpetrinet.TransEvClassMapping;
//import org.processmining.plugins.petrinet.replayer.algorithms.costbasedcomplete.CostBasedCompleteParam;
//import org.processmining.plugins.petrinet.replayresult.PNRepResult;
//import org.processmining.plugins.petrinet.replayresult.StepTypes;
//import org.processmining.plugins.replayer.replayresult.SyncReplayResult;
//
//@Plugin(name = "MULog", returnLabels = { "Experiment" }, returnTypes = { XLog.class }, parameterLabels = { "Petri net",
//		"Event Log" })
//public class ExperimentMU {
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - old", requiredParameterLabels = { 0 })
//	public XLog runOld(final UIPluginContext context, XLog log) throws Exception {
//		//			String filename = "Discovery_AlignmentRes_";
//		//			csvWriter = initWriter(filename);
//		//			XesXmlGZIPParser parser = new XesXmlGZIPParser();
//
//		for (XTrace t : log) {
//			for (XEvent e : t) {
////				XAttributeLiteral a = (XAttributeLiteral) e.getAttributes().get("Verrichttekst_1");
//				String label = XConceptExtension.instance().extractName(e);
////				XAttributeLiteral newA = new XAttributeLiteralImpl("NewLabel", label);
////				XConceptExtension.instance().assignName(e, a.getValue());
//				XAttribute newA = e.getAttributes().get("OriginalLabel");
//				if(newA != null){
//					XConceptExtension.instance().assignName(e, ((XAttributeLiteral) newA).getValue());
//				}					
//			}
//		}
//		return log;
//
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - log moves", requiredParameterLabels = { 0 })
//	public XLog visualize(PluginContext context, PNRepResult logReplayResult) {
//		PLog poLog = null;
//		XLog log = null;
//		PetrinetGraph graph = null;
//		TransEvClassMapping mapping = null;
//		CostBasedCompleteParam param = null;
//		try {
//			PAlignmentResultConnection conn = context.getConnectionManager().getFirstConnection(
//					PAlignmentResultConnection.class, context, logReplayResult);
//
//			poLog = conn.getObjectWithRole(PAlignmentResultConnection.PARTIALLOG);
//			log = conn.getObjectWithRole(PAlignmentResultConnection.LINEARLOG);
//			graph = conn.getObjectWithRole(PAlignmentResultConnection.PN);
//			mapping = conn.getObjectWithRole(PAlignmentResultConnection.MAPPING);
//			param = conn.getObjectWithRole(PAlignmentResultConnection.ALGPARAMETER);
//
//		} catch (Exception exc) {
//			context.log("No net can be found for this log replay result");
//			return null;
//		}
//
//		XLog testLog = poLog.getXLog();
//		for (SyncReplayResult srr : logReplayResult) {
//			POSyncReplayResult posrr = (POSyncReplayResult) srr;
//
//			for (int traceIndex : posrr.getTraceIndex()) {
//				//				out.println("Trace " + traceIndex + " measure : =================");
//				XTrace newTrace = testLog.get(traceIndex);
//
//				for (int i = 0; i < posrr.getStepTypes().size(); i++) {
//					StepTypes stepType = posrr.getStepTypes().get(i);
//					int newEventIndex = posrr.getIndeces().get(i);
//					if (newEventIndex < 0) {
//						continue;
//					}
//					XEvent e = newTrace.get(newEventIndex);
//					String label = XConceptExtension.instance().extractName(e);
//					XAttribute trueLabelAttr = null;
//					//			
//
//					if (stepType.equals(StepTypes.L)) {
//						trueLabelAttr = XExperimentNoiseExtension.getTrueNoiseAttr();
//						//				
//					} else if (stepType.equals(StepTypes.LMGOOD)) {
//						trueLabelAttr = XExperimentNoiseExtension.getTrueLabelAttr(label);
//
//					} else {
//						System.out.println("Errorooorororororor");
//					}
//					e.getAttributes().put(trueLabelAttr.getKey(), trueLabelAttr);
//
//				}
//			}
//		}
//		//poLog.get()		
//
//		return testLog;
//	}
//}
