package org.processmining.xlu.matching.config.gui;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
import org.processmining.partialorder.ptrace.param.PTraceParameterDialog;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;

public class PTraceParameterMatchDialog extends PTraceParameterDialog implements EGMatchConfigDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 2125128217586163658L;
	private EGMatchConfiguration config;
	
	public PTraceParameterMatchDialog(UIPluginContext context, final EGMatchConfiguration config) {
		super(context, config.getPTraceParameter());
		this.config = config;
	}

	public String getTitle() {
		return "PTrace Builder";
	}

	public JComponent showDialog() {
		return this;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		PTraceType selectedType = getSelectedPTraceType();
		config.getPTraceParameter().setType(selectedType);

	}

}
