package org.processmining.xlu.matching.models;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

public class RepEGraphUtil {
	
	public static List<Integer> getListOfNumTracesOfEdges(RepEGraph graph){
		List<Integer> num = new ArrayList<>();
		for(Map<Integer, Integer> traces : graph.getEdgeRepresentedEdges().values()){
			num.add(traces.size());
		}
		return num;
	}

	public static Collection<? extends Integer> getListOfNumTracesOfNodes(RepEGraph graph) {
		List<Integer> num = new ArrayList<>();
		for(Map<Integer, Integer> traces : graph.getNodeRepresentedNodes().values()){
			num.add(traces.size());
		}
		return num;
	}

}
