package org.processmining.xlu.matching.models.collection;

import java.util.Comparator;
import java.util.List;

import org.processmining.xlu.matching.models.MatchMapping;

public interface MatchMappings extends Iterable<MatchMapping> {
	
	public abstract List<MatchMapping> getAllMappings();

	public abstract List<MatchMapping> getOptimalMappings();

	public abstract List<MatchMapping> getAllMappings(int traceIndexI, int traceIndexJ);

	public abstract MatchMapping getAnOptimalMapping(int traceIndexI, int traceIndexJ);

	public abstract void add(int traceIndexI, int traceIndexJ, List<MatchMapping> mappings);
	
	public abstract void add(int traceIndexI, int traceIndexJ, MatchMapping mapping);
	
	public Comparator<MatchMapping> getMappingComparator();
	
	
}
