package org.processmining.xlu.matching.preprocessing;

import java.util.Map;

import org.deckfour.xes.classification.XEventClasses;
import org.processmining.partialorder.ptrace.model.PTrace;
import org.processmining.xlu.matching.models.EGraph;

public interface PTraceToEGConverter {

	
	public EGraph convert(PTrace trace);
	
//	/**
//	 * Set a list of event classes that indicates the label of event. 
//	 * Moreover, the index of an event class in classes is used for ordering
//	 * @param classes
//	 */
//	public void setClasses(XEventClasses classes);
	
	
	public Map<String, Integer> getMapNodeLabelToIndex();

	public void setClasses(XEventClasses classes);
}
