package org.processmining.xlu.matching.zexperiment;

import java.util.List;

import org.deckfour.xes.classification.XEventClassifier;
import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
import org.processmining.xlu.matching.plugins.alg.MatchingAlg;
import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;

public class EGMatchExpConfigurationSpace {

	private XEventClassifier classifier;
	private PTraceType[] ptraceTypes;
	private List<MatchingAlg> algs;
	private List<CostStrategyConfiguration> costConfigs;

	public XEventClassifier getClassifier() {
		return classifier;
	}

	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}

	public void setPTraceTypes(PTraceType[] egTypeSelections) {
		this.ptraceTypes = egTypeSelections;
		
	}

	public void setMatchAlgorithms(List<MatchingAlg> algs) {
		this.algs = algs;
	}

	public void setCostConfigs(List<CostStrategyConfiguration> costConfigs) {
		this.costConfigs = costConfigs;
	}

	public PTraceType[] getPTraceTypes() {
		return this.ptraceTypes;
	}

	
	public List<MatchingAlg> getMatchingAlgorithms(){
		return this.algs;
	}
	
	public List<CostStrategyConfiguration> getCostConfigs(){
		return this.costConfigs;
	}
	
	
	

}
