package org.processmining.xlu.matching.zexperiment.verification;

import org.deckfour.xes.model.XLog;
import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.models.MatchMapping;
import org.processmining.xlu.matching.models.RepEGraph;
import org.processmining.xlu.matching.zexperiment.model.FusionBinaryResult;

public interface EGMatchTestVerificationMethod {

	public void computeCorrectness(RepEGraph representiveGraph, EGraph g1, EGraph g2, MatchMapping matchMapping,
			XLog log, FusionBinaryResult mappingQuality);
}
