package org.processmining.xlu.pgraph.vis;

import java.awt.Color;
import java.util.HashMap;
import java.util.Map;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.partialorder.plugins.vis.PartialVisualType;
import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.pgraph.vis.filter.PGraphFilter;

public class PGraphParameter {
	
	Map<XEventClass, Color> map;
	Map<Integer, Color> mapTraceId;
	private PartialVisualType visType = PartialVisualType.AS_IS;
	private PGraphFilter<ENode> filter;

	

	public PGraphParameter(){
		map = new HashMap<>();
		mapTraceId = new HashMap<>();
	}
	
	public void setEvtMap(Map<XEventClass, Color> map){
		this.map = map;
	}
	
	public void setTraceMap(Map<Integer, Color> mapTraceId){
		this.mapTraceId = mapTraceId;
	}
	
	
	public Map<XEventClass, Color> getEvtColorMap(){
		return map;
	}
	
	public Map<Integer, Color> getTraceColorMap(){
		return mapTraceId;
	}

	public void setVisType(PartialVisualType visType) {
		this.visType = visType;
	}
	
	public PartialVisualType getVisType(){
		return visType;
	}

	//TODO REMOVE
	public void setNodeFilter(PGraphFilter<ENode> eventfreqFilter) {
		this.filter = eventfreqFilter;
	}
	
	public PGraphFilter<ENode> getNodeFilter(){
		return filter;
	}
	
	
}
