package org.processmining.xlu.pgraph.vis.converter;

import org.processmining.partialorder.models.graph.PartialOrderGraph;
import org.processmining.xlu.pgraph.vis.PGraphParameter;
import org.processmining.xlu.pgraph.vis.panel.PGraphInfoView;
import org.processmining.xlu.pgraph.vis.panel.PGraphVisView;


public interface PGraphConverter<K> {
	
	public PartialOrderGraph convert(K object);
	
	public PartialOrderGraph convert(K object, PGraphParameter parameter);

	public PGraphInfoView<K> createPGraphInfoView(PartialOrderGraph graph, K object);
	
	public PGraphVisView<K> createPGraphVisView(PartialOrderGraph graph, PGraphInfoView<K> infoView);

//	public void addColorMap(Map<Object, Color> colorMap);
	
	

}
