package org.processmining.xlu.pgraph.vis.filter.panel;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.xlu.pgraph.vis.filter.PGraphFilterMaxNumber;
import org.processmining.xlu.relabel.visualization.RelabelMainPanel;

import com.fluxicon.slickerbox.factory.SlickerDecorator;

public class FilterViewMaxNumber extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -9176596696803362815L;

	public FilterViewMaxNumber(final PGraphFilterMaxNumber<?> filter){
//		setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setBackground(Color.DARK_GRAY);
		setForeground(Color.WHITE);
		
		final JLabel labelMax = RelabelMainPanel.createLabel(this, "Show maximal number of instance graph: ");
		labelMax.setAlignmentX(Component.LEFT_ALIGNMENT);
		add(labelMax);
		
//		add(SlickerFactory.instance().createLabel(""));

		final JComboBox<Integer> select = new JComboBox<Integer>(new Integer[] { 10, 50, 100, Integer.MAX_VALUE });
		select.setSelectedIndex(0);
		SlickerDecorator.instance().decorate(select);
		select.setAlignmentX(Component.LEFT_ALIGNMENT);
		select.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				Integer value = (Integer) select.getSelectedItem();
				filter.setMaxNumber(value);
			}
		});

		add(select);
		
	}
	
}
