package org.processmining.xlu.relabel.model;

import org.deckfour.xes.model.XEvent;

public class TEvent {

	private int trIndex;
	private int evIndex;
	private XEvent ev;

	public TEvent(int traceIndex, int eventIndex) {
		this.trIndex = traceIndex;
		this.evIndex = eventIndex;
//		this.ev = ev;
	}

	public int getTrIndex() {
		return trIndex;
	}

	public void setTraceIndex(int trIndex) {
		this.trIndex = trIndex;
	}

	public int getEventIndex() {
		return evIndex;
	}

	public void setEventIndex(int evIndex) {
		this.evIndex = evIndex;
	}

	@Override
	public boolean equals(Object o) {
		if (!(o instanceof TEvent)) {
			return false;
		}

		TEvent e = (TEvent) o;

		return e.trIndex == this.trIndex && e.evIndex == this.evIndex;
	}

	public int hashCode() {
		int hash = 23;
		hash = (hash * 31) + trIndex;
		hash = (hash * 31) + evIndex;
		return hash;
	}

	@Override
	public String toString() {
		return "[" + trIndex + "," + evIndex + "]";
	}
}
