package org.processmining.xlu.relabel.plugin.detection;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.classification.XEventNameClassifier;

public class ILDetectorParam {

	
	int maxNumLabels;
	XEventClassifier classifier; 
	
	public static ILDetectorParam createDefaultParam() {
		ILDetectorParam param = new ILDetectorParam();
		return param;
	}
	
	public static ILDetectorParam createDefaultParam(XEventClassifier classifier) {
		ILDetectorParam param = new ILDetectorParam();
		param.setClassifier(classifier);
		return param;
	}
	
	public ILDetectorParam(){
		maxNumLabels = 8;
		classifier = new XEventNameClassifier();
	}


	public int getMaxNumLabels() {
		return maxNumLabels;
	}
	
	public XEventClassifier getClassifier() {
		return classifier;
	}


	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}

	
}
