package org.processmining.xlu.relabel.plugin.detection;

import java.util.Collection;
import java.util.Set;

import org.deckfour.xes.model.XLog;

import gnu.trove.set.hash.THashSet;

public class RelabelScopeAbs<M, S> implements RelabelScope<M, S> {

	private M model;
	private S submodel;
	private Set<String> labelScope;
	private XLog origLog;
	private XLog sublog;

	public M getModel() {
		return model;
	}

	public S getSubmodel() {
		return submodel;
	}

	public Set<String> getLabelScope() {
		return labelScope;
	}

	public XLog getLogForRelabel() {
		return sublog;
	}

	public XLog getOrigLog() {
		return origLog;
	}

	
	
	public void setSubModel(S submodel) {
		this.submodel = submodel;
	}

	public void setLabelScope(Collection<String> impreciseLabels) {
		this.labelScope = new THashSet<>(impreciseLabels);
	}

	public void setOrigLog(XLog origLog) {
		this.origLog = origLog;
	}

	public void setSublog(XLog sublog) {
		this.sublog = sublog;
	}
	
	public void setModel(M model) {
		this.model = model;
	}


}
